import 'package:flutter/material.dart';
import 'package:provider_mvc/controller.dart';
import '../controllers/slider_controller.dart';
import '../controllers/home_controller.dart';
import 'package:provider_mvc/view.dart';

import '../views/slider_view.dart';

class HomeScreen extends View<HomeController> {
  @override
  Widget builder(
      BuildContext context, HomeController controller, Widget widget) {
    return Scaffold(
      backgroundColor: controller.bg,
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            SliderView(Colors.red),
            SliderView(Colors.green),
            SliderView(Colors.blue),
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: () {
          Controller.of<SliderController>().forEach((ctrl) => ctrl.value = 0);
          controller.bg = Colors.black;
        },
        child: Icon(Icons.refresh),
      ),
    );
  }

  @override
  HomeController create(BuildContext context) =>
      Controller.put<HomeController>(HomeController());
}
