library provider_mvc;

import 'package:flutter/widgets.dart';
import 'package:provider/provider.dart';
import 'package:provider_mvc/controller.dart';

/// View base class
abstract class View<T extends Controller> extends StatelessWidget {
  /// Returns an instance of the controller associated to view
  T create(BuildContext context);

  /// Returns the view widget
  Widget builder(BuildContext context, T controller, Widget widget);

  /// View widget build function - not to override
  @override
  Widget build(BuildContext context) => ChangeNotifierProvider<T>(
        create: create,
        child: Consumer<T>(builder: builder),
      );
}
